<?php
require_once "loxberry_system.php";
include 'solcast_functions.php';
error_reporting(0);

//CONFIG
$file_config = $lbpconfigdir . '/solcast_config.json';
$file_log_i  = $lbplogdir . '/solcast_sum.log';
$file_data	 = $lbpdatadir."/fc_midnight.txt";
$config      = json_decode(file_get_contents($file_config), true);


$debug   = $config['debug'];
$ms_ip = $config['miniserver']['ip'];
$ms_port = $config['miniserver']['port'];
$send_mqtt = $config['send_mqtt'];
$send_udp = $config['send_udp'];

if (!isset($send_udp) && !isset($send_mqtt)) {
	$send_mqtt = 1;
}

$save_fc = $_GET['save_fc'];

$filename_data_1 = $lbpdatadir . '/solcast_system_1.txt';
$filename_data_2 = $lbpdatadir . '/solcast_system_2.txt';
$filename_data_3 = $lbpdatadir . '/solcast_system_3.txt';
$filename_data_4 = $lbpdatadir . '/solcast_system_4.txt';
$filename_data_5 = $lbpdatadir . '/solcast_system_5.txt';

$array=array();

if (file_exists($filename_data_1)) {
$tmp = file_get_contents($filename_data_1);
$array[1] = json_decode($tmp, true);
}
if (file_exists($filename_data_2)) {
$tmp = file_get_contents($filename_data_2);
$array[2] = json_decode($tmp, true);
}
if (file_exists($filename_data_3)) {
$tmp = file_get_contents($filename_data_3);
$array[3] = json_decode($tmp, true);
}
if (file_exists($filename_data_4)) {
$tmp = file_get_contents($filename_data_4);
$array[4] = json_decode($tmp, true);
}
if (file_exists($filename_data_5)) {
$tmp = file_get_contents($filename_data_5);
$array[5] = json_decode($tmp, true);
}

$arr_submit = Array();
for ($x = 0; $x <= 23; $x++) {
$arr_submit['hourly_td_w'][$x] = $array[1]['hourly_td_w'][$x] + $array[2]['hourly_td_w'][$x] + $array[3]['hourly_td_w'][$x] + $array[4]['hourly_td_w'][$x];
$arr_submit['hourly_td_kw'][$x] = $array[1]['hourly_td_kw'][$x] + $array[2]['hourly_td_kw'][$x] + $array[3]['hourly_td_kw'][$x] + $array[4]['hourly_td_kw'][$x];
$arr_submit['hourly_tm_w'][$x] = $array[1]['hourly_tm_w'][$x] + $array[2]['hourly_tm_w'][$x] + $array[3]['hourly_tm_w'][$x] + $array[4]['hourly_tm_w'][$x];
$arr_submit['hourly_tm_kw'][$x] = $array[1]['hourly_tm_kw'][$x] + $array[2]['hourly_tm_kw'][$x] + $array[3]['hourly_tm_kw'][$x] + $array[4]['hourly_tm_kw'][$x];
}
$arr_submit['total']['td_kw'] = $array['1']['total']['td_kw'] + $array['2']['total']['td_kw'] + $array['3']['total']['td_kw'] + $array['4']['total']['td_kw'] + $array['5']['total']['td_kw'];
$arr_submit['total']['td_kw'] = $array['1']['total']['td_kw'] + $array['2']['total']['td_kw'] + $array['3']['total']['td_kw'] + $array['4']['total']['td_kw'] + $array['5']['total']['td_kw'];
$arr_submit['total']['td_w'] = $array['1']['total']['td_w'] + $array['2']['total']['td_w'] + $array['3']['total']['td_w'] + $array['4']['total']['td_w'] + $array['5']['total']['td_w'];
$arr_submit['total']['tm_kw'] = $array['1']['total']['tm_kw'] + $array['2']['total']['tm_kw'] + $array['3']['total']['tm_kw'] + $array['4']['total']['tm_kw'] + $array['5']['total']['tm_kw'];
$arr_submit['total']['tm_w'] = $array['1']['total']['tm_w'] + $array['2']['total']['tm_w'] + $array['3']['total']['tm_w'] + $array['4']['total']['tm_w'] + $array['5']['total']['tm_w'];

$arr_submit['next']['3_kw'] = $array['1']['next']['3_kw'] + $array['2']['next']['3_kw'] + $array['3']['next']['3_kw'] + $array['4']['next']['3_kw'] + $array['5']['next']['3_kw']; 
$arr_submit['next']['3_w'] = $array['1']['next']['3_w'] + $array['2']['next']['3_w'] + $array['3']['next']['3_w'] + $array['4']['next']['3_w'] + $array['5']['next']['3_w'];
$arr_submit['next']['6_kw'] = $array['1']['next']['6_kw'] + $array['2']['next']['6_kw'] + $array['3']['next']['6_kw'] + $array['4']['next']['6_kw'] + $array['5']['next']['6_kw'];
$arr_submit['next']['6_w'] = $array['1']['next']['6_w'] + $array['2']['next']['6_w'] + $array['3']['next']['6_w'] + $array['4']['next']['6_w'] + $array['5']['next']['6_w'];
$arr_submit['next']['9_kw'] = $array['1']['next']['9_kw'] + $array['2']['next']['9_kw'] + $array['3']['next']['9_kw'] + $array['4']['next']['9_kw'] + $array['5']['next']['9_kw'];
$arr_submit['next']['9_w'] = $array['1']['next']['9_w'] + $array['2']['next']['9_w'] + $array['3']['next']['9_w'] + $array['4']['next']['9_w'] + $array['5']['next']['9_w'];
$arr_submit['next']['12_kw'] = $array['1']['next']['12_kw'] + $array['2']['next']['12_kw'] + $array['3']['next']['12_kw'] + $array['4']['next']['12_kw'] + $array['5']['next']['12_kw'];
$arr_submit['next']['12_w'] = $array['1']['next']['12_w'] + $array['2']['next']['12_w'] + $array['3']['next']['12_w'] + $array['4']['next']['12_w'] + $array['5']['next']['12_w'];
$arr_submit['next']['24_kw'] = $array['1']['next']['24_kw'] + $array['2']['next']['24_kw'] + $array['3']['next']['24_kw'] + $array['4']['next']['24_kw'] + $array['5']['next']['24_kw'];
$arr_submit['next']['24_w'] = $array['1']['next']['24_w'] + $array['2']['next']['24_w'] + $array['3']['next']['24_w'] + $array['4']['next']['24_w'] + $array['5']['next']['24_w'];

$arr_submit['daytime']['morning_kw'] = $array['1']['daytime']['morning_kw'] + $array['2']['daytime']['morning_kw'] + $array['3']['daytime']['morning_kw'] + $array['4']['daytime']['morning_kw'] + $array['5']['daytime']['morning_kw'];
$arr_submit['daytime']['morning_w'] = $array['1']['daytime']['morning_w'] + $array['2']['daytime']['morning_w'] + $array['3']['daytime']['morning_w'] + $array['4']['daytime']['morning_w'] + $array['5']['daytime']['morning_w'];
$arr_submit['daytime']['afternoon_kw'] = $array['1']['daytime']['afternoon_kw'] + $array['2']['daytime']['afternoon_kw'] + $array['3']['daytime']['afternoon_kw'] + $array['4']['daytime']['afternoon_kw'] + $array['5']['daytime']['afternoon_kw'];
$arr_submit['daytime']['afternoon_w'] = $array['1']['daytime']['afternoon_w'] + $array['2']['daytime']['afternoon_w'] + $array['3']['daytime']['afternoon_w'] + $array['4']['daytime']['afternoon_w'] + $array['5']['daytime']['afternoon_w'];

$arr_submit['daytime_tm']['morning_kw'] = $array['1']['daytime_tm']['morning_kw'] + $array['2']['daytime_tm']['morning_kw'] + $array['3']['daytime_tm']['morning_kw'] + $array['4']['daytime_tm']['morning_kw'] + $array['5']['daytime_tm']['morning_kw'];
$arr_submit['daytime_tm']['morning_w'] = $array['1']['daytime_tm']['morning_w'] + $array['2']['daytime_tm']['morning_w'] + $array['3']['daytime_tm']['morning_w'] + $array['4']['daytime_tm']['morning_w'] + $array['5']['daytime_tm']['morning_w'];
$arr_submit['daytime_tm']['afternoon_kw'] = $array['1']['daytime_tm']['afternoon_kw'] + $array['2']['daytime_tm']['afternoon_kw'] + $array['3']['daytime_tm']['afternoon_kw'] + $array['4']['daytime_tm']['afternoon_kw'] + $array['5']['daytime_tm']['afternoon_kw'];
$arr_submit['daytime_tm']['afternoon_w'] = $array['1']['daytime_tm']['afternoon_w'] + $array['2']['daytime_tm']['afternoon_w'] + $array['3']['daytime_tm']['afternoon_w'] + $array['4']['daytime_tm']['afternoon_w'] + $array['5']['daytime_tm']['afternoon_w'];

$arr_hourly_kw = array();
for ($x = 0; $x <= 23; $x++) {
$arr_hourly_kw[$x] = $array['1']['hourly_td_kw'][$x] + $array['2']['hourly_td_kw'][$x] + $array['3']['hourly_td_kw'][$x] + $array['4']['hourly_td_kw'][$x]  + $array['5']['hourly_td_kw'][$x];
}
for ($x = 0; $x <= 23; $x++) {
$arr_hourly_w[$x] = $array['1']['hourly_td_w'][$x] + $array['2']['hourly_td_w'][$x] + $array['3']['hourly_td_w'][$x] + $array['4']['hourly_td_w'][$x]  + $array['5']['hourly_td_w'][$x];
}

arsort($arr_hourly_kw);
$arr_hourly_top4_hour = array_keys($arr_hourly_kw);
$arr_hourly_top4_kw[0] = $arr_hourly_kw[$arr_hourly_top4_hour[0]];
$arr_hourly_top4_kw[1] = $arr_hourly_kw[$arr_hourly_top4_hour[1]];
$arr_hourly_top4_kw[2] = $arr_hourly_kw[$arr_hourly_top4_hour[2]];
$arr_hourly_top4_kw[3] = $arr_hourly_kw[$arr_hourly_top4_hour[3]];
arsort($arr_hourly_w);
$arr_hourly_top4_hour = array_keys($arr_hourly_w);
$arr_hourly_top4_w[0] = $arr_hourly_w[$arr_hourly_top4_hour[0]];
$arr_hourly_top4_w[1] = $arr_hourly_w[$arr_hourly_top4_hour[1]];
$arr_hourly_top4_w[2] = $arr_hourly_w[$arr_hourly_top4_hour[2]];
$arr_hourly_top4_w[3] = $arr_hourly_w[$arr_hourly_top4_hour[3]];

$arr_submit['hourly_top4_td_kw'][0] = $arr_hourly_top4_kw[0];
$arr_submit['hourly_top4_td_kw'][1] = $arr_hourly_top4_kw[1];
$arr_submit['hourly_top4_td_kw'][2] = $arr_hourly_top4_kw[2];
$arr_submit['hourly_top4_td_kw'][3] = $arr_hourly_top4_kw[3];
$arr_submit['hourly_top4_td_w'][0] = $arr_hourly_top4_w[0];
$arr_submit['hourly_top4_td_w'][1] = $arr_hourly_top4_w[1];
$arr_submit['hourly_top4_td_w'][2] = $arr_hourly_top4_w[2];
$arr_submit['hourly_top4_td_w'][3] = $arr_hourly_top4_w[3];
$arr_submit['hourly_top4_td_hour'][0] = $arr_hourly_top4_hour[0];
$arr_submit['hourly_top4_td_hour'][1] = $arr_hourly_top4_hour[1];
$arr_submit['hourly_top4_td_hour'][2] = $arr_hourly_top4_hour[2];
$arr_submit['hourly_top4_td_hour'][3] = $arr_hourly_top4_hour[3];

if ($save_fc == 1) {
$filename=($file_data);  
$handle = fopen ( $filename, "w" ); 
		fwrite ( $handle, "total_all_td_w=\"".$arr_submit['total']['td_w']."\"\n" );
		fwrite ( $handle, "total_all_td_kw=\"".$arr_submit['total']['td_kw']."\"\n" );		
		fwrite ( $handle, "total_all_tm_w=\"".$arr_submit['total']['tm_w']."\"\n" );
		fwrite ( $handle, "total_all_tm_kw=\"".$arr_submit['total']['tm_kw']."\"\n" );
		
		fwrite ( $handle, "total_1_td_w=\"".$array['1']['total']['td_w']."\"\n" );
		fwrite ( $handle, "total_2_td_w=\"".$array['2']['total']['td_w']."\"\n" );
		fwrite ( $handle, "total_3_td_w=\"".$array['3']['total']['td_w']."\"\n" );
		fwrite ( $handle, "total_4_td_w=\"".$array['4']['total']['td_w']."\"\n" );
		fwrite ( $handle, "total_5_td_w=\"".$array['5']['total']['td_w']."\"\n" );
		
		fwrite ( $handle, "total_1_td_kw=\"".$array['1']['total']['td_kw']."\"\n" );
		fwrite ( $handle, "total_2_td_kw=\"".$array['2']['total']['td_kw']."\"\n" );
		fwrite ( $handle, "total_3_td_kw=\"".$array['3']['total']['td_kw']."\"\n" );
		fwrite ( $handle, "total_4_td_kw=\"".$array['4']['total']['td_kw']."\"\n" );
		fwrite ( $handle, "total_5_td_kw=\"".$array['5']['total']['td_kw']."\"\n" );
		
		fwrite ( $handle, "total_1_tm_w=\"".$array['1']['total']['tm_w']."\"\n" );
		fwrite ( $handle, "total_2_tm_w=\"".$array['2']['total']['tm_w']."\"\n" );
		fwrite ( $handle, "total_3_tm_w=\"".$array['3']['total']['tm_w']."\"\n" );
		fwrite ( $handle, "total_4_tm_w=\"".$array['4']['total']['tm_w']."\"\n" );
		fwrite ( $handle, "total_5_tm_w=\"".$array['5']['total']['tm_w']."\"\n" );
		
		fwrite ( $handle, "total_1_tm_kw=\"".$array['1']['total']['tm_kw']."\"\n" );
		fwrite ( $handle, "total_2_tm_kw=\"".$array['2']['total']['tm_kw']."\"\n" );
		fwrite ( $handle, "total_3_tm_kw=\"".$array['3']['total']['tm_kw']."\"\n" );
		fwrite ( $handle, "total_4_tm_kw=\"".$array['4']['total']['tm_kw']."\"\n" );
		fwrite ( $handle, "total_5_tm_kw=\"".$array['5']['total']['tm_kw']."\"\n" );	
		fclose ( $handle ); 
}

$arr_submit[mn] = parse_ini_file($file_data, TRUE);
$system='sum';
if($send_udp == 1) {
send_udp($system, $arr_submit, $ms_ip, $ms_port);
}
if($send_mqtt == 1) {
send_mqtt($system, $arr_submit);
}

if ($debug == 1) {
log_i($arr_submit, $file_log_i);
}